Index: trunk/sources/HeuristicLab.Clients.Hive.Slave.TrayIcon/3.3/HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive.Slave.TrayIcon/3.3/HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3.csproj	(revision 13131)
+++ trunk/sources/HeuristicLab.Clients.Hive.Slave.TrayIcon/3.3/HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3.csproj	(revision 13133)
@@ -127,10 +127,4 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
-    <Compile Include="TrayIconInstaller.cs">
-      <SubType>Component</SubType>
-    </Compile>
-    <Compile Include="TrayIconInstaller.Designer.cs">
-      <DependentUpon>TrayIconInstaller.cs</DependentUpon>
-    </Compile>
     <EmbeddedResource Include="MainWindow.resx">
       <DependentUpon>MainWindow.cs</DependentUpon>
Index: trunk/sources/HeuristicLab.Clients.Hive.Slave.TrayIcon/3.3/TrayIconInstaller.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive.Slave.TrayIcon/3.3/TrayIconInstaller.Designer.cs	(revision 13131)
+++ 	(revision )
@@ -1,52 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Clients.Hive.SlaveCore.SlaveTrayIcon {
-  partial class TrayIconInstaller {
-    /// <summary>
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary>
-    /// Required method for Designer support - do not modify
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      components = new System.ComponentModel.Container();
-    }
-
-    #endregion
-  }
-}
Index: trunk/sources/HeuristicLab.Clients.Hive.Slave.TrayIcon/3.3/TrayIconInstaller.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive.Slave.TrayIcon/3.3/TrayIconInstaller.cs	(revision 13131)
+++ 	(revision )
@@ -1,41 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System.Collections;
-using System.ComponentModel;
-using System.Diagnostics;
-
-
-namespace HeuristicLab.Clients.Hive.SlaveCore.SlaveTrayIcon {
-  [RunInstaller(true)]
-  public partial class TrayIconInstaller : System.Configuration.Install.Installer {
-
-    public TrayIconInstaller() {
-      InitializeComponent();
-    }
-
-    public override void Commit(IDictionary savedState) {
-      base.Commit(savedState);
-      //TODO: disable on quiet install (for admins)?
-      Process.Start(Context.Parameters["TARGETDIR"].ToString() + "HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon.exe");
-    }
-  }
-}