Index: /trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.Designer.cs	(revision 13137)
+++ /trunk/sources/HeuristicLab.Scripting.Views/3.3/CSharpScriptView.Designer.cs	(revision 13138)
@@ -65,9 +65,13 @@
       // executionTimeLabel
       // 
-      this.executionTimeLabel.Location = new System.Drawing.Point(394, 393);
+      this.executionTimeLabel.Location = new System.Drawing.Point(409, 3);
       // 
       // executionTimeTextBox
       // 
-      this.executionTimeTextBox.Location = new System.Drawing.Point(483, 390);
+      this.executionTimeTextBox.Location = new System.Drawing.Point(498, 0);
+      // 
+      // infoTabControl
+      // 
+      this.infoTabControl.Size = new System.Drawing.Size(637, 110);
       // 
       // splitContainer1
@@ -141,6 +145,6 @@
       this.errorListTabPage.ResumeLayout(false);
       this.splitContainer1.Panel1.ResumeLayout(false);
-      this.splitContainer1.Panel1.PerformLayout();
       this.splitContainer1.Panel2.ResumeLayout(false);
+      this.splitContainer1.Panel2.PerformLayout();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
       this.splitContainer1.ResumeLayout(false);
Index: /trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.Designer.cs	(revision 13137)
+++ /trunk/sources/HeuristicLab.Scripting.Views/3.3/ExecutableScriptView.Designer.cs	(revision 13138)
@@ -37,10 +37,13 @@
       this.SuspendLayout();
       // 
-      // splitContainer1.Panel1
+      // splitContainer1
       // 
-      this.splitContainer1.Panel1.Controls.Add(this.executionTimeTextBox);
-      this.splitContainer1.Panel1.Controls.Add(this.executionTimeLabel);
-      this.splitContainer1.Panel1.Controls.SetChildIndex(this.executionTimeTextBox, 0);
-      this.splitContainer1.Panel1.Controls.SetChildIndex(this.executionTimeLabel, 0);
+      // 
+      // splitContainer1.Panel2
+      // 
+      this.splitContainer1.Panel2.Controls.Add(this.executionTimeLabel);
+      this.splitContainer1.Panel2.Controls.Add(this.executionTimeTextBox);
+      this.splitContainer1.Panel2.Controls.SetChildIndex(this.executionTimeTextBox, 0);
+      this.splitContainer1.Panel2.Controls.SetChildIndex(this.executionTimeLabel, 0);
       // 
       // nameTextBox
@@ -63,7 +66,7 @@
       // executionTimeLabel
       // 
-      this.executionTimeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.executionTimeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.executionTimeLabel.AutoSize = true;
-      this.executionTimeLabel.Location = new System.Drawing.Point(589, 396);
+      this.executionTimeLabel.Location = new System.Drawing.Point(604, 3);
       this.executionTimeLabel.Name = "executionTimeLabel";
       this.executionTimeLabel.Size = new System.Drawing.Size(83, 13);
@@ -73,6 +76,6 @@
       // executionTimeTextBox
       // 
-      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.executionTimeTextBox.Location = new System.Drawing.Point(678, 393);
+      this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.executionTimeTextBox.Location = new System.Drawing.Point(693, 0);
       this.executionTimeTextBox.Name = "executionTimeTextBox";
       this.executionTimeTextBox.ReadOnly = true;
@@ -98,6 +101,6 @@
       this.errorListTabPage.ResumeLayout(false);
       this.splitContainer1.Panel1.ResumeLayout(false);
-      this.splitContainer1.Panel1.PerformLayout();
       this.splitContainer1.Panel2.ResumeLayout(false);
+      this.splitContainer1.Panel2.PerformLayout();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).EndInit();
       this.splitContainer1.ResumeLayout(false);
Index: /trunk/sources/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 13137)
+++ /trunk/sources/HeuristicLab.Scripting.Views/3.3/ScriptView.Designer.cs	(revision 13138)
@@ -118,11 +118,13 @@
       // infoTabControl
       // 
+      this.infoTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
       this.infoTabControl.Controls.Add(this.outputTabPage);
       this.infoTabControl.Controls.Add(this.errorListTabPage);
-      this.infoTabControl.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.infoTabControl.Location = new System.Drawing.Point(0, 0);
+      this.infoTabControl.Location = new System.Drawing.Point(0, 2);
       this.infoTabControl.Name = "infoTabControl";
       this.infoTabControl.SelectedIndex = 0;
-      this.infoTabControl.Size = new System.Drawing.Size(832, 112);
+      this.infoTabControl.Size = new System.Drawing.Size(832, 110);
       this.infoTabControl.TabIndex = 1;
       // 
@@ -133,5 +135,5 @@
       this.outputTabPage.Name = "outputTabPage";
       this.outputTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.outputTabPage.Size = new System.Drawing.Size(824, 86);
+      this.outputTabPage.Size = new System.Drawing.Size(824, 84);
       this.outputTabPage.TabIndex = 1;
       this.outputTabPage.Text = "Output";
@@ -147,5 +149,5 @@
       this.outputTextBox.ReadOnly = true;
       this.outputTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
-      this.outputTextBox.Size = new System.Drawing.Size(818, 80);
+      this.outputTextBox.Size = new System.Drawing.Size(818, 78);
       this.outputTextBox.TabIndex = 0;
       this.outputTextBox.WordWrap = false;