Index: stable/HeuristicLab.Algorithms.DataAnalysis.Views/3.4/GaussianProcessRegressionSolutionLineChartView.cs
===================================================================
--- stable/HeuristicLab.Algorithms.DataAnalysis.Views/3.4/GaussianProcessRegressionSolutionLineChartView.cs	(revision 12009)
+++ stable/HeuristicLab.Algorithms.DataAnalysis.Views/3.4/GaussianProcessRegressionSolutionLineChartView.cs	(revision 13145)
@@ -70,6 +70,6 @@
         var mean = Content.EstimatedTrainingValues.ToArray();
         var s2 = Content.EstimatedTrainingVariance.ToArray();
-        var lower = mean.Zip(s2, (m, s) => m - 1.96 * Math.Sqrt(s)).ToArray();
-        var upper = mean.Zip(s2, (m, s) => m + 1.96 * Math.Sqrt(s)).ToArray();
+        var lower = mean.Zip(s2, GetLowerConfBound).ToArray();
+        var upper = mean.Zip(s2, GetUpperConfBound).ToArray();
         this.chart.Series[ESTIMATEDVALUES_TRAINING_SERIES_NAME].Points.DataBindXY(Content.ProblemData.TrainingIndices.ToArray(), lower, upper);
         this.InsertEmptyPoints(this.chart.Series[ESTIMATEDVALUES_TRAINING_SERIES_NAME]);
@@ -83,6 +83,6 @@
         mean = Content.EstimatedTestValues.ToArray();
         s2 = Content.EstimatedTestVariance.ToArray();
-        lower = mean.Zip(s2, (m, s) => m - 1.96 * Math.Sqrt(s)).ToArray();
-        upper = mean.Zip(s2, (m, s) => m + 1.96 * Math.Sqrt(s)).ToArray();
+        lower = mean.Zip(s2, GetLowerConfBound).ToArray();
+        upper = mean.Zip(s2, GetUpperConfBound).ToArray();
         this.chart.Series[ESTIMATEDVALUES_TEST_SERIES_NAME].Points.DataBindXY(Content.ProblemData.TestIndices.ToArray(), lower, upper);
         this.InsertEmptyPoints(this.chart.Series[ESTIMATEDVALUES_TEST_SERIES_NAME]);
@@ -93,6 +93,6 @@
         mean = Content.EstimatedValues.ToArray();
         s2 = Content.EstimatedVariance.ToArray();
-        lower = mean.Zip(s2, (m, s) => m - 1.96 * Math.Sqrt(s)).ToArray();
-        upper = mean.Zip(s2, (m, s) => m + 1.96 * Math.Sqrt(s)).ToArray();
+        lower = mean.Zip(s2, GetLowerConfBound).ToArray();
+        upper = mean.Zip(s2, GetUpperConfBound).ToArray();
         List<double> allLower = allIndices.Select(index => lower[index]).ToList();
         List<double> allUpper = allIndices.Select(index => upper[index]).ToList();
@@ -265,6 +265,6 @@
             mean = Content.EstimatedValues.ToArray();
             s2 = Content.EstimatedVariance.ToArray();
-            lower = mean.Zip(s2, (m, s) => m - 1.96 * Math.Sqrt(s)).ToArray();
-            upper = mean.Zip(s2, (m, s) => m + 1.96 * Math.Sqrt(s)).ToArray();
+            lower = mean.Zip(s2, GetLowerConfBound).ToArray();
+            upper = mean.Zip(s2, GetUpperConfBound).ToArray();
             lower = indices.Select(index => lower[index]).ToArray();
             upper = indices.Select(index => upper[index]).ToArray();
@@ -274,6 +274,6 @@
             mean = Content.EstimatedTrainingValues.ToArray();
             s2 = Content.EstimatedTrainingVariance.ToArray();
-            lower = mean.Zip(s2, (m, s) => m - 1.96 * Math.Sqrt(s)).ToArray();
-            upper = mean.Zip(s2, (m, s) => m + 1.96 * Math.Sqrt(s)).ToArray();
+            lower = mean.Zip(s2, GetLowerConfBound).ToArray();
+            upper = mean.Zip(s2, GetUpperConfBound).ToArray();
             break;
           case ESTIMATEDVALUES_TEST_SERIES_NAME:
@@ -281,6 +281,6 @@
             mean = Content.EstimatedTestValues.ToArray();
             s2 = Content.EstimatedTestVariance.ToArray();
-            lower = mean.Zip(s2, (m, s) => m - 1.96 * Math.Sqrt(s)).ToArray();
-            upper = mean.Zip(s2, (m, s) => m + 1.96 * Math.Sqrt(s)).ToArray();
+            lower = mean.Zip(s2, GetLowerConfBound).ToArray();
+            upper = mean.Zip(s2, GetUpperConfBound).ToArray();
             break;
         }
@@ -295,4 +295,13 @@
     }
 
+    private double GetLowerConfBound(double m, double s) {
+      return m - 1.96 * Math.Sqrt(s);
+    }
+
+
+    private double GetUpperConfBound(double m, double s) {
+      return m + 1.96 * Math.Sqrt(s);
+    }
+
     // workaround as per http://stackoverflow.com/questions/5744930/datapointcollection-clear-performance
     private static void ClearPointsQuick(DataPointCollection points) {